SystemOrganization addCategory: #'Mercury-Prototype-MetaLevel'!
SystemOrganization addCategory: #'Mercury-Prototype-Middleware'!
SystemOrganization addCategory: #'Mercury-Prototype-ReflectionFactory'!
SystemOrganization addCategory: #'Mercury-Prototype-SecurityPolicy'!
SystemOrganization addCategory: #'Mercury-Prototype-DebuggingSeed'!
SystemOrganization addCategory: #'Mercury-Prototype-Tests'!
SystemOrganization addCategory: #'Mercury-Prototype-MyProject'!
SystemOrganization addCategory: #'Mercury-Prototype-RunTimeDebuggingSupport'!

TestCase subclass: #SanityLocalTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Tests'!

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:43'!
testExample1

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aPackageMirror := aRemoteEnvironmentMirror packageNamed: 'Graphics-Primitives'.
	aClassMirror := aPackageMirror classNamed: 'Point'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror objInstVarNamed: #x put: 100.
	anObjectMirror objInstVarNamed: #y put: 200.
	self assert: aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror.
	self assert: aPackageMirror class = PackageIntercessionMirror.
	self assert: aClassMirror class = ClassIntercessionMirror.
	self assert: anObjectMirror class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) objAsString  = '100'.
	self assert: (anObjectMirror objInstVarNamed: #y) objAsString  = '200'.! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:43'!
testExample2

	|aRemoteEnvironmentMirror responce|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aRemoteEnvironmentMirror evaluate: '3 / 0' onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		self assert: aRemoteExceptionMirror class = ExceptionIntercessionMirror.
		LocalDebuggingClient debug: aRemoteExceptionMirror
	].
	
	responce := aRemoteEnvironmentMirror evaluate: '3+1' onRemoteExceptionDo: [:exMirror | ].
	self assert: (responce class = ObjectIntercessionMirror).
	self assert: (responce baseObject = 4).! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:44'!
testExample3

	"works remotely and locally only when it is not run as test"

	|aRemoteEnvironmentMirror exceptionMirror interruptedProcessMirror aTempObjMirror aContextMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aRemoteEnvironmentMirror evaluate: '[ |x| 3 / 0. Transcript show: x. ] value' onRemoteExceptionDo: [:exMirror |
		interruptedProcessMirror := exMirror interruptedProcess.
		aContextMirror := interruptedProcessMirror contextAt: 2.
		aContextMirror tempNamed: 't1' put: 'Can you see me ?'.
		self assert: (aContextMirror tempNamed: 't1') baseObject = 'Can you see me ?'.
		interruptedProcessMirror over.
		interruptedProcessMirror proceed.
	]
	! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 15:07'!
testExample4

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aPackageMirror := aRemoteEnvironmentMirror newPackageNamed: #NewPackage.
	self assert: (aRemoteEnvironmentMirror packageNamed: #NewPackage) class = PackageIntercessionMirror.
	aClassMirror := aPackageMirror newClassNamed: #NewClass.
	aClassMirror := aClassMirror ivs: #('x' 'y').	
	aClassMirror addMethod: 'hypothesis: aNumber
														Transcript show: aNumber. 
														^ 3 / aNumber'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror perform: #hypothesis: withArguments: #(0) onRemoteExceptionDo: [:aRemoteExceptionMirror |
		 LocalDebuggingClient debug: aRemoteExceptionMirror.
		self assert: (aRemoteExceptionMirror class = ExceptionIntercessionMirror).
	].
	self assert: (anObjectMirror perform: #hypothesis: withArguments: #(3) onRemoteExceptionDo: [:exMirror | ]) baseObject = 1.! !

TestCase subclass: #TestAPIexamplesRemote
	instanceVariableNames: 'interruptedProcessMirror aTempMirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Tests'!

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 12:55'!
testExample1

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aPackageMirror := aRemoteEnvironmentMirror packageNamed: 'Graphics-Primitives'.
	aClassMirror := aPackageMirror classNamed: 'Point'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror objInstVarNamed: #x put: 100.
	anObjectMirror objInstVarNamed: #y put: 200.
	self assert: aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror.
	self assert: aPackageMirror class = PackageIntercessionMirror.
	self assert: aClassMirror class = ClassIntercessionMirror.
	self assert: anObjectMirror class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) objAsString  = '100'.
	self assert: (anObjectMirror objInstVarNamed: #y) objAsString  = '200'.! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/12/2013 19:30'!
testExample2

	|aRemoteEnvironmentMirror responce|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror evaluate: '3 / 0' onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		self assert: aRemoteExceptionMirror class = ExceptionIntercessionMirror.
		LocalDebuggingClient debug: aRemoteExceptionMirror
	].
	
	responce := aRemoteEnvironmentMirror evaluate: '3+1' onRemoteExceptionDo: [:exMirror | ].
	self assert: (responce class = ObjectIntercessionMirror).
	self assert: (responce baseObject = 4).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/12/2013 19:30'!
testExample3

	"works remotely and locally only when it is not run as test"

	|aRemoteEnvironmentMirror exceptionMirror interruptedProcessMirror aTempObjMirror aContextMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror evaluate: '[ |x| 3 / 0. Transcript show: x. ] value' onRemoteExceptionDo: [:exMirror |
		interruptedProcessMirror := exMirror interruptedProcess.
		aContextMirror := interruptedProcessMirror contextAt: 2.
		aContextMirror tempNamed: 't1' put: 'Can you see me ?'.
		self assert: (aContextMirror tempNamed: 't1') baseObject = 'Can you see me ?'.
		interruptedProcessMirror over.
		interruptedProcessMirror proceed.
	]
	! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2013 16:23'!
testExample4

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aPackageMirror := aRemoteEnvironmentMirror newPackageNamed: #NewPackage.
	self assert: (aRemoteEnvironmentMirror packageNamed: #NewPackage) class = PackageIntercessionMirror.
	aClassMirror := aPackageMirror newClassNamed: #NewClass.
	aClassMirror := aClassMirror ivs: #('x' 'y').	
	aClassMirror addMethod: 'hypothesis: aNumber
														Transcript show: aNumber. 
														^ 3 / aNumber'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror perform: #hypothesis: withArguments: #(0) onRemoteExceptionDo: [:aRemoteExceptionMirror |
		 LocalDebuggingClient debug: aRemoteExceptionMirror.
		self assert: (aRemoteExceptionMirror class = ExceptionIntercessionMirror).
	].
	self assert: (anObjectMirror perform: #hypothesis: withArguments: #(3) onRemoteExceptionDo: [:exMirror | ]) baseObject = 1.! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/22/2013 18:13'!
testExample5

 	| aClassMirror aPackageMirror aRemoteEnvironmentMirror aRemoteExceptionMirror responce |
	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aPackageMirror := aRemoteEnvironmentMirror packageNamed: 'Graphics-Primitives'.
	aClassMirror := aPackageMirror classNamed: 'Point'.
	aClassMirror onReceive: [:reifications :reflectogram |
		reifications message selector = #new ifTrue: [
			reifications trigger halt.
			reflectogram override: true.
			reflectogram returnValue: (reflectogram defaultAction).
			reflectogram remove.
		]
	].
	responce := aRemoteEnvironmentMirror evaluate: 'TestClass run' onRemoteExceptionDo: [:anExceptionMirror |
		aRemoteExceptionMirror := anExceptionMirror.		
	].

	(Delay forSeconds: 2) wait.

	self assert: (aRemoteExceptionMirror class = ExceptionIntercessionMirror).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2013 15:21'!
testExample6

 	| aClassMirror aPackageMirror aRemoteEnvironmentMirror aTempObjMirror aContextMirror |
	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror evaluate: '[ |x| x := Point x:3 y:100. 3 / 0. Transcript show: x. ] value' onRemoteExceptionDo: [:exMirror |
		interruptedProcessMirror := exMirror interruptedProcess.
		aContextMirror := interruptedProcessMirror contextAt: 2.
		aTempObjMirror := aContextMirror tempNamed: 't1'.
		aTempObjMirror resolveLocallyToDepth: 3.
	].

	(Delay forSeconds: 2) wait.	

	self assert: (aTempObjMirror isLocallyResolved).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/20/2013 12:48'!
testExample7

	|aRemoteEnvironmentMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
	self assert: (aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror).
	[
		aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
		self assert: (aRemoteEnvironmentMirror class = EnvironmentIntrospectionMirror).
	] forkWithIntrospectionReflectionPolicy.
	(Delay forSeconds: 2) wait.! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:54'!
testExceptionPush

	|aRemoteEnvironmentMirror pushedExceptionMirror|

	pushedExceptionMirror := nil.

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		LocalDebuggingClient debug: aRemoteExceptionMirror.
		pushedExceptionMirror := aRemoteExceptionMirror.
	].
	
	aRemoteEnvironmentMirror run: '3 / 0'. "otherside will unload debugging support"
	(Delay forSeconds: 15) wait.
	self assert: (pushedExceptionMirror class = ExceptionIntercessionMirror).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 11:51'!
testReflectionPolicy

	|aRemoteEnvironmentMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
	self assert: (aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror).
	[
		aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
		self assert: (aRemoteEnvironmentMirror class = EnvironmentIntrospectionMirror).
	] forkWithIntrospectionReflectionPolicy.
	(Delay forSeconds: 2) wait.! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 4/3/2013 17:07'!
cleanHandler 
	handler ifNotNil: [handler class removeInstance: handler].
	handler := nil.! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler

	^ handler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler: aHandler

	handler := aHandler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:28'!
reflectionPolicy 

	^ reflectionPolicy ifNil: [^ IntercessionSecurityPolicy ]! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:31'!
reflectionPolicy: aReflectionPolicy

	reflectionPolicy := aReflectionPolicy ! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:41'!
unhandledException

	^ uException! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:42'!
unhandledException: anException

	uException := anException ! !

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess 

	^ handlerProcess! !

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess: aHandlerProcess

	handlerProcess := aHandlerProcess! !

!BlockClosure methodsFor: '*Mercury-Prototype' stamp: 'NickPapoulias 1/14/2013 14:14'!
forkWithIntrospectionReflectionPolicy

	^ self newProcess
			reflectionPolicy: IntrospectionSecurityPolicy;
			resume.! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 4/24/2013 13:45'!
confirm: aString

	^ true! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/14/2013 12:54'!
contextStack 

	^ contextStack! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 4/24/2013 13:44'!
inform: aString! !

Object subclass: #DebuggingSeed
	instanceVariableNames: ''
	classVariableNames: 'registeredRequestor'
	poolDictionaries: ''
	category: 'Mercury-Prototype-DebuggingSeed'!

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:30'!
authenticate

	"authentication is automatically handled by the middleware in the prototype see: Seamless authentication manager"
	
	self loadDebuggingSupport.
	
	^ Smalltalk globals! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/3/2013 13:51'!
interruptedProcesses

	^ DebuggingHandler activeInstances collect: [:instance | instance process]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:22'!
loadDebuggingSupport

	(Smalltalk globals keys includes: #RunTimeDebuggingSupport) ifFalse: [

		Gofer it
			url: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145';
			package: 'Mercury-Prototype-RunTimeDebuggingSupport';
			load.
			
	]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/23/2013 17:20'!
newUnhandledExceptionFrom: aHandler

	self loadDebuggingSupport.

	registeredRequestor ifNotNil: [[registeredRequestor newRemoteException: aHandler exception] fork].! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:28'!
pushNewExceptionsTo: aRequestor

	registeredRequestor := aRequestor ! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:14'!
run: aString

	self unloadDebuggingSupport.
	[Compiler evaluate: aString] fork.! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/3/2013 13:51'!
unhandledExceptions 

	^ DebuggingHandler activeInstances collect: [:instance | instance exception]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:32'!
unloadDebuggingSupport

	Gofer it
		package: 'Mercury-Prototype-RunTimeDebuggingSupport';
		unload.! !

Object subclass: #EnvironmentIdentifier
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

Object subclass: #LocalDebuggingClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MyProject'!

!LocalDebuggingClient class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 15:22'!
debug: aRemoteEnvironmentMirror ! !

!LocalDebuggingClient methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 14:21'!
debug: aRemoteEnvironmentMirror ! !

Object subclass: #MercurySeamlessDeamon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Middleware'!

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:57'!
initialize

	super initialize. 
	self shutDown.! !

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:57'!
shutDown

	SeamlessDeamonManager default shutDown. ! !

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:58'!
startUp

	SeamlessDeamonManager default startUp. ! !

Object subclass: #Mirror
	instanceVariableNames: 'baseObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!Mirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:59'!
isMirror

	^ true! !

Mirror subclass: #ObjectIntrospectionMirror
	instanceVariableNames: 'runTimeSupportMirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ObjectIntrospectionMirror subclass: #ClassIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ClassIntrospectionMirror subclass: #ClassIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:36'!
addIv: anIvName

	runTimeSupportMirror addInstVarNamed: anIvName inClass: baseObject! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/5/2013 16:23'!
addMethod: aString

	^ runTimeSupportMirror addMethod: aString inClass: baseObject.! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
ivs: ivArray

	runTimeSupportMirror setIvs: ivArray forClass: baseObject! !

!ClassIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:09'!
onNew: aBlock

	runTimeSupportMirror onNewForClass: baseObject do: aBlock! !

!ClassIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:09'!
onRead: aBlock

	runTimeSupportMirror onReadForClass: baseObject do: aBlock! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/21/2013 11:52'!
onReceive: aBlock

	runTimeSupportMirror onReceiveFor: baseObject do: aBlock! !

!ClassIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:08'!
onWrite: aBlock

	runTimeSupportMirror onWriteForClass: baseObject do: aBlock! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/21/2013 17:44'!
perform: aSelector withArguments: arguments onRemoteExceptionDo: aBlock
	
	|responce|
	
	
	responce := runTimeSupportMirror perform: aSelector withReceiver: baseObject andArguments: arguments.
	responce class = ExceptionIntercessionMirror ifTrue: [
		[aBlock value: responce] fork.
	] ifFalse: [
		^ responce.
	]! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 11:29'!
removeIv: anIvName

	runTimeSupportMirror removeInstVarNamed: anIvName inClass: baseObject! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:46'!
removeMethod: aSelector

	runTimeSupportMirror removeMethod: aSelector inClass: baseObject  ! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:44'!
superclass: aClassNameAsString

	runTimeSupportMirror vm_changeSuperClassOf: baseObject To: aClassNameAsString ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:40'!
definition

	^ runTimeSupportMirror definitionOfClass: baseObject.! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:34'!
format

	^ (self objAt: 3) baseObject ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:36'!
instSpec

	^ (self format bitShift: -7) bitAnd: 16rF! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:32'!
instVarIndexFor: instVarName

	^ runTimeSupportMirror instVarIndexFor: instVarName forClass: baseObject ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:42'!
instVarNames

	^ runTimeSupportMirror ivsForClass: baseObject! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:35'!
instanceSize

	^ ((self format bitShift: -10) bitAnd: 16rC0) + ((self format bitShift: -1) bitAnd: 16r3F) - 1! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2013 16:52'!
isMeta

	^ runTimeSupportMirror isMetaForClass: baseObject.! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:37'!
isVariable

	^ self instSpec >= 2! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 12:04'!
methodAt: aMethodName
	
	^ runTimeSupportMirror methodOf: baseObject at: aMethodName ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:42'!
methodNames

	^ runTimeSupportMirror selectorsOfClass: baseObject! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:41'!
methodsInProtocol: aProtocolNameAsString
	
	^ runTimeSupportMirror methodsOf: baseObject inProtocol: aProtocolNameAsString ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:43'!
newInstance

	^ runTimeSupportMirror newInstanceForClass: baseObject! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/8/2013 15:35'!
package

	^ runTimeSupportMirror packageOfClass: baseObject.! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:10'!
protocols
	
	^ runTimeSupportMirror protocolsForClass: baseObject ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2013 17:02'!
soleInstance 
	
	self isMeta ifTrue: [
		^ runTimeSupportMirror soleInstanceFor: baseObject.		
	]! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:34'!
superclass

	^ self objAt: 1! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:33'!
systemName

	^ (self objAt: 7) baseObject! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:38'!
typeOfClass

	self instSpec = 12 ifTrue:[^#compiledMethod]. "Very special!!"
	self instSpec >= 8 ifTrue:[^#bytes].
	((self instSpec >= 8) not and:[(self instSpec >= 6)]) ifTrue:[^#words].
	self instSpec = 4 ifTrue:[^#weak].
	self instSpec >= 2 ifTrue:[^#variable].
	^#normal.! !

ObjectIntrospectionMirror subclass: #ContextIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ContextIntrospectionMirror subclass: #ContextIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ContextIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
tempNamed: aTempName put: anObject

	anObject isMirror ifTrue: [
		runTimeSupportMirror inContext: baseObject forTempNamed: aTempName put: anObject baseObject.
	] ifFalse: [
		runTimeSupportMirror inContext: baseObject forTempNamed: aTempName put: anObject.
	]! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/16/2013 12:03'!
dictionaryForContext

	^ runTimeSupportMirror dictionaryForContext: baseObject! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/16/2013 12:06'!
dictionaryForReceiver

	^ runTimeSupportMirror dictionaryForReceiverInContext: baseObject! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:44'!
method

	^ runTimeSupportMirror methodForContext: baseObject ! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:44'!
receiver

	^ runTimeSupportMirror receiverForContext: baseObject! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/11/2013 18:38'!
source

	^ runTimeSupportMirror sourceForContext: baseObject! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:44'!
tempNamed: aTempName

	^ runTimeSupportMirror tempNamed: aTempName inContext: baseObject! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:44'!
tempNames

	^ runTimeSupportMirror tempNamesForContext: baseObject! !

ObjectIntrospectionMirror subclass: #EnvironmentIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

EnvironmentIntrospectionMirror subclass: #EnvironmentIntercessionMirror
	instanceVariableNames: 'exceptionCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/12/2013 15:20'!
evaluate: aString onRemoteExceptionDo: aBlock

	|responce|
	
	
	responce := runTimeSupportMirror evaluate: aString.
	responce class = ExceptionIntercessionMirror ifTrue: [
		[aBlock value: responce] fork.
		^ responce
	] ifFalse: [
		^ responce.
	]
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:32'!
globalAt: aName put: aMirror

	runTimeSupportMirror globalAt: aName put: aMirror baseObject 
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:48'!
newPackageNamed: aPackageName

	^ runTimeSupportMirror newPackageNamed: aPackageName.
	
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 17:08'!
newRemoteException: anException
	
	Transcript show: anException class.
	exceptionCallback value: (Reflection on: anException) ! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
onRemoteExceptionDo: aBlock

	exceptionCallback := aBlock.
	runTimeSupportMirror registerExceptionListener: self! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:34'!
removePackageNamed: aPackageName
	
	runTimeSupportMirror removePackageNamed: aPackageName! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
run: aString
	
	runTimeSupportMirror run: aString! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:25'!
environmentAddress

	^ runTimeSupportMirror environmentAddress 

	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:44'!
globalAt: aName

	^ runTimeSupportMirror globalAt: aName


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:45'!
globalNames

	^ runTimeSupportMirror globalNames
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:46'!
interruptedProcesses

	^ runTimeSupportMirror interruptedProcesses
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:46'!
packageNamed: aPackageNameAsString

	^ runTimeSupportMirror packageNamed: aPackageNameAsString
	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:46'!
packageNames

	^ runTimeSupportMirror packageNames
	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:47'!
unhandledExceptions

	^ runTimeSupportMirror unhandledExceptions
	

	
	! !

ObjectIntrospectionMirror subclass: #ExceptionIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ExceptionIntrospectionMirror subclass: #ExceptionIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ExceptionIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:14'!
description

	^ runTimeSupportMirror descriptionForException: baseObject ! !

!ExceptionIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:49'!
interruptedProcess 

	^ runTimeSupportMirror handlerProcessForException: baseObject! !

ObjectIntrospectionMirror subclass: #MethodIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

MethodIntrospectionMirror subclass: #MethodIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!MethodIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:26'!
recompileWithSource: sourceAsString

	self methodClass addMethod: sourceAsString  ! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:49'!
methodClass

	^ runTimeSupportMirror classOfMethod: baseObject! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:18'!
protocol

	^ runTimeSupportMirror protocolOfMethod: baseObject ! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:18'!
selector

	^ runTimeSupportMirror selectorOfMethod: baseObject ! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 18:18'!
source

	^ runTimeSupportMirror sourceOfMethod: baseObject 	! !

ObjectIntrospectionMirror subclass: #ObjectIntercessionMirror
	instanceVariableNames: 'resolutionDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:21'!
changeClassTo: aClassName

	runTimeSupportMirror changeClassTo: aClassName of: baseObject. ! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 16:22'!
halt

	runTimeSupportMirror objectHalt: baseObject.! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2013 15:28'!
isLocallyResolved 

	^ (resolutionDict = nil) not! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:19'!
objAt: anIndex put: aValue

	aValue isMirror ifTrue: [
		runTimeSupportMirror vm_instVarOf: baseObject at: anIndex put: aValue baseObject 			
	] ifFalse: [
		runTimeSupportMirror vm_instVarOf: baseObject at: anIndex  put: aValue 
	]

	! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:23'!
objIndexedAt: anIndex put: aValue

	aValue isMirror ifTrue: [
		runTimeSupportMirror vm_indexedOf: baseObject at: anIndex put: aValue baseObject 			
	] ifFalse: [
		runTimeSupportMirror vm_indexedOf: baseObject at: anIndex  put: aValue 
	]

	! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
objInstVarNamed: anIvName put: aValue

	aValue isMirror ifTrue: [
		runTimeSupportMirror vm_instVarOf: baseObject named: anIvName  put: aValue baseObject 			
	] ifFalse: [
		runTimeSupportMirror vm_instVarOf: baseObject named: anIvName  put: aValue 
	]

	! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:14'!
onArgument: aBlock

	runTimeSupportMirror onArgumentFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/21/2013 12:06'!
onInteractionWith: aMirror do: aBlock

	runTimeSupportMirror onInteractionFor: baseObject with: aMirror baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:14'!
onRead: aBlock

	runTimeSupportMirror onReadFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:03'!
onReceive: aBlock

	runTimeSupportMirror onReceiveFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:14'!
onSend: aBlock

	runTimeSupportMirror onSendFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:14'!
onStore: aBlock

	runTimeSupportMirror onStoreFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'instrumentation' stamp: 'NickPapoulias 6/21/2013 12:14'!
onWrite: aBlock

	runTimeSupportMirror onWriteFor: baseObject do: aBlock! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:49'!
perform: aSelector withArguments: arguments onRemoteExceptionDo: aBlock
	
	|responce|
	
	
	responce := runTimeSupportMirror perform: aSelector withReceiver: baseObject andArguments: arguments.
	responce class = ExceptionIntercessionMirror ifTrue: [
		[aBlock value: responce] fork.
	] ifFalse: [
		^ responce.
	]! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2013 15:17'!
resolveLocallyToDepth: n

	| objectGraph reflectionClasses |
	resolutionDict := runTimeSupportMirror resolveLocallyToDepth: n forObject: baseObject. "get the objectGraph, and
	lazily create mirrors locally"! !

!ObjectIntrospectionMirror class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:53'!
newWith: aBaseObject and: aRunTimeSupport

	^ self new
		initializeWith: aBaseObject and: aRunTimeSupport! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/5/2013 11:13'!
baseObject

	^ baseObject ! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:29'!
initializeWith: aBaseObject and: aRunTimeSupportMirror

	baseObject := aBaseObject.
	runTimeSupportMirror := aRunTimeSupportMirror.! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:25'!
instSize

	^ runTimeSupportMirror vm_instSizeOf: baseObject! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:26'!
instanceVarNames

	^ self objClass instVarNames! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
objAsString
	
	^ runTimeSupportMirror vm_objAsStringFor: baseObject.! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:40'!
objAt: anIndex
	
	^ runTimeSupportMirror vm_instVarOf: baseObject at: anIndex! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:16'!
objBasicSize
	
	^ runTimeSupportMirror vm_basicSizeOf: baseObject.! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:41'!
objClass

	^ runTimeSupportMirror vm_classOf: baseObject! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:15'!
objClassName

	^ runTimeSupportMirror vm_classNameOf: baseObject! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:28'!
objFormat

	^ runTimeSupportMirror vm_objectFormatOf: baseObject ! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:41'!
objIndexedAt: anIndex
	
	^ runTimeSupportMirror vm_indexedOf: baseObject at: anIndex! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:41'!
objInstVarNamed: anIvName
	
	^ runTimeSupportMirror vm_instVarOf: baseObject named: anIvName! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 16:29'!
objType

	^ runTimeSupportMirror vm_objectTypeOf: baseObject ! !

ObjectIntrospectionMirror subclass: #PackageIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

PackageIntrospectionMirror subclass: #PackageIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!PackageIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:50'!
newClassNamed: aNewClassName

	^ runTimeSupportMirror newClassNamed: aNewClassName inPackage: baseObject! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:50'!
classNamed: aClassNameAsString

	^ runTimeSupportMirror classNamed: aClassNameAsString inPackage: baseObject! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:50'!
classes

	^ runTimeSupportMirror classNamesInPackage: baseObject! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 20:12'!
packageName

	^ runTimeSupportMirror nameOfPackage: baseObject ! !

ObjectIntrospectionMirror subclass: #ProcessIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ProcessIntrospectionMirror subclass: #ProcessIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:35'!
into

	runTimeSupportMirror intoForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
over 

	runTimeSupportMirror overForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
proceed 

	runTimeSupportMirror proceedForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/12/2013 13:03'!
recompileCurrentMethod: sourceCodeForMethod

	^ runTimeSupportMirror recompileCurrentMethodTo: sourceCodeForMethod forProcess: baseObject ! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:36'!
restart

	runTimeSupportMirror restartForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/23/2013 12:58'!
through

	runTimeSupportMirror throughForProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:51'!
contextAt: aContextIndex
	
	^ runTimeSupportMirror contextAt: aContextIndex forProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:51'!
currentContext

	^ runTimeSupportMirror contextForProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/8/2013 14:32'!
currentContextIndex

	^ runTimeSupportMirror currentContextIndexForProcess: baseObject.! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 19:02'!
method

	^ self currentContext method! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 19:02'!
methodClass

	^ self method methodClass! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 19:11'!
processName

	^ runTimeSupportMirror nameForProcess: baseObject ! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 19:02'!
receiver

	^ self currentContext receiver ! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/8/2013 15:05'!
sourceRange

	^ runTimeSupportMirror sourceRangeForProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/8/2013 13:56'!
stack

	^ runTimeSupportMirror stackForProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:51'!
where

	^ runTimeSupportMirror whereForProcess: baseObject! !

Mirror subclass: #RunTimeMirror
	instanceVariableNames: 'runTimeSupport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!RunTimeMirror class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 11:27'!
newWith: runTimeSupport

	^ self new
		initializeWith: runTimeSupport ! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 11:32'!
addInstVarNamed: anIvName inClass: aClass

	runTimeSupport addInstVarNamed: anIvName inClass: aClass! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 2/19/2013 13:55'!
addMethod: aString inClass: aClass

	^ runTimeSupport addMethod: aString inClass: aClass.

! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 11:31'!
changeClassTo: aClassNameAsString of: anObject
	
	runTimeSupport changeClassTo: aClassNameAsString of: anObject. ! !

!RunTimeMirror methodsFor: 'package' stamp: 'NickPapoulias 1/31/2013 11:34'!
classNamed: aClassNameAsString inPackage: aPackage

	^ Reflection on: (runTimeSupport classNamed: aClassNameAsString inPackage: aPackage)! !

!RunTimeMirror methodsFor: 'package' stamp: 'NickPapoulias 1/31/2013 11:35'!
classNamesInPackage: aPackage 

	^ (runTimeSupport classNamesInPackage: aPackage) asLocalObject ! !

!RunTimeMirror methodsFor: 'method' stamp: 'NickPapoulias 1/31/2013 11:36'!
classOfMethod: aMethod

	^ Reflection on: (runTimeSupport classOfMethod: aMethod)! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:38'!
contextAt: aContextIndex forProcess: aProcess
	
	^ Reflection on: (runTimeSupport contextAt: aContextIndex forProcess: aProcess)! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:38'!
contextForProcess: aProcess 

	^ Reflection on: (runTimeSupport contextForProcess: aProcess)

	! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 14:48'!
currentContextIndexForProcess: aProcess

	^ runTimeSupport currentContextIndexForProcess: aProcess

	! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:38'!
definitionOfClass: aClass

	^ runTimeSupport definitionOfClass: aClass. ! !

!RunTimeMirror methodsFor: 'exception' stamp: 'NickPapoulias 1/31/2013 12:39'!
descriptionForException: anException

	^ runTimeSupport descriptionForException: anException! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 4/22/2013 12:37'!
dictionaryForContext: aContext

	^ (runTimeSupport dictionaryForContext: aContext) asLocalObject ! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 4/22/2013 12:37'!
dictionaryForReceiverInContext: aContext

	^ (runTimeSupport dictionaryForReceiverInContext: aContext) asLocalObject ! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:38'!
environmentAddress 

	^ runTimeSupport environmentAddress ! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:39'!
evaluate: aString

	^ Reflection on: (runTimeSupport evaluate: aString)! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:40'!
globalAt: aName

	^ Reflection on: (runTimeSupport globalAt: aName)! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:41'!
globalAt: aName put: aMirror

	runTimeSupport globalAt: aName put: aMirror baseObject ! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:41'!
globalNames 

	^ runTimeSupport globalNames asLocalObject ! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:41'!
globalsDictionary

	^ runTimeSupport globalsDictionary! !

!RunTimeMirror methodsFor: 'exception' stamp: 'NickPapoulias 1/31/2013 12:39'!
handlerProcessForException: anException

	^ Reflection on: (runTimeSupport handlerProcessForException: anException)! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 1/31/2013 11:43'!
inContext: aContext forTempNamed: aTempName put: anObject

	runTimeSupport inContext: aContext forTempNamed: aTempName put: anObject.! !

!RunTimeMirror methodsFor: 'initialize' stamp: 'NickPapoulias 1/31/2013 11:28'!
initializeWith: aRunTimeSupport 

	runTimeSupport := aRunTimeSupport 
	! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:46'!
interruptedProcesses

	|processMirrors|
	
	processMirrors := OrderedCollection new.
	
	runTimeSupport interruptedProcesses do: [:process | 
		processMirrors add: (Reflection on: process)	
	].

	^ processMirrors.
	! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 11:44'!
intoForProcess: aProcess 

	runTimeSupport intoForProcess: aProcess

	! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 16:54'!
isMetaForClass: aClass

	^ runTimeSupport isMetaForClass: aClass. ! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 11:45'!
ivsForClass: aClass

	^ (runTimeSupport ivsForClass: aClass) asLocalObject  ! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 6/22/2013 20:14'!
kernelClasses

	^ {'Object'  . 'ClassDescription'  . 'ContextPart'  . 'SystemDictionary'  . 'Exception'  . 'CompiledMethod'  . 'PackageInfo'  . 'Process' } 
	! !

!RunTimeMirror methodsFor: 'misc' stamp: 'NickPapoulias 1/31/2013 11:26'!
metaLevelUpdate: aSystemAnnouncement! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 1/31/2013 11:46'!
methodForContext: aContext 

	^ Reflection on: (runTimeSupport methodForContext: aContext) ! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 12:06'!
methodOf: aClass at: methodName 

	^ Reflection on: (runTimeSupport methodOf: aClass at: methodName)! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:44'!
methodsOf: aClass inProtocol: aProtocolName 
	
	^ (runTimeSupport methodsOf: aClass  inProtocol: aProtocolName) asLocalObject ! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 11:50'!
nameForProcess: aProcess 

	^ runTimeSupport nameForProcess: aProcess

	! !

!RunTimeMirror methodsFor: 'package' stamp: 'NickPapoulias 1/31/2013 11:51'!
nameOfPackage: aPackage 

	^ runTimeSupport nameOfPackage: aPackage ! !

!RunTimeMirror methodsFor: 'package' stamp: 'NickPapoulias 1/31/2013 11:54'!
newClassNamed: aNewClassName inPackage: aPackage

	^ Reflection on: (runTimeSupport newClassNamed: aNewClassName inPackage: aPackage)! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 11:54'!
newInstanceForClass: aClass

	^ Reflection on: (runTimeSupport newInstanceForClass: aClass)! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:54'!
newPackageNamed: aPackageName

	^ Reflection on: (runTimeSupport newPackageNamed: aPackageName).! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 16:23'!
objectHalt: anObject
	
	runTimeSupport objectHalt: anObject! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:32'!
onArgumentFor: anObject do: aBlock

	runTimeSupport onArgumentFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:39'!
onInteractionFor: anObject with: anotherObject do: aBlock

	runTimeSupport onInteractionFor: baseObject with: anotherObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:32'!
onNewForClass: aClass do: aBlock

	runTimeSupport onNewForClass: baseObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:33'!
onReadFor: anObject do: aBlock

	runTimeSupport onReadFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:31'!
onReadForClass: aClass do: aBlock

	runTimeSupport onReadForClass: baseObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 17:43'!
onReceiveFor: anObject do: aBlock

	runTimeSupport onReceiveFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:35'!
onSendFor: anObject do: aBlock

	runTimeSupport onSendFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:35'!
onStoreFor: anObject do: aBlock

	runTimeSupport onStoreFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:35'!
onWriteFor: anObject do: aBlock

	runTimeSupport onWriteFor: anObject do: aBlock! !

!RunTimeMirror methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 14:31'!
onWriteForClass: aClass do: aBlock

	runTimeSupport onWriteForClass: baseObject do: aBlock! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 11:55'!
overForProcess: aProcess 

	runTimeSupport overForProcess: aProcess

	! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:55'!
packageNamed: aPackageNameAsString 

	^ Reflection on: (runTimeSupport packageNamed: aPackageNameAsString)! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 11:58'!
packageNames

	^ runTimeSupport packageNames asLocalObject 
	! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 4/8/2013 15:35'!
packageOfClass: aClass

	^ Reflection on: (runTimeSupport packageOfClass: aClass).! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:00'!
perform: aSelector withReceiver: aReceiver andArguments: arguments
	
	^ Reflection on: (runTimeSupport perform: aSelector withReceiver: aReceiver andArguments: arguments).! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:00'!
proceedForProcess: aProcess 

	runTimeSupport proceedForProcess: aProcess

	! !

!RunTimeMirror methodsFor: 'method' stamp: 'NickPapoulias 1/31/2013 12:00'!
protocolOfMethod: aMethod

	^ runTimeSupport protocolOfMethod: aMethod ! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:15'!
protocolsForClass: aClass
	
	^ (runTimeSupport protocolsForClass: aClass) asLocalObject ! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 1/31/2013 12:39'!
receiverForContext: aContext 

	^ Reflection on: (runTimeSupport receiverForContext: aContext)! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 4/12/2013 13:04'!
recompileCurrentMethodTo: sourceCodeForMethod forProcess: aProcess

	^ Reflection on: (runTimeSupport recompileCurrentMethodTo: sourceCodeForMethod forProcess: aProcess)

	! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:01'!
registerExceptionListener: aRequestor

	runTimeSupport registerExceptionListener: aRequestor! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:02'!
removeInstVarNamed: anIvName inClass: aClass

	runTimeSupport removeInstVarNamed: anIvName inClass: aClass ! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:03'!
removeMethod: aString inClass: aClass

	runTimeSupport removeMethod: aString inClass: aClass

! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:04'!
removePackageNamed: aPackageName

	runTimeSupport removePackageNamed: aPackageName! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2013 15:10'!
resolveLocallyToDepth: n forObject:  anObject
	
	
	^ (runTimeSupport resolveLocallyToDepth: n forObject: anObject) asLocalObject. "adapt serialization at runtime to transfer the object graph"! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:04'!
restartForProcess: aProcess 

	runTimeSupport restartForProcess: aProcess
	! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:04'!
run: aString

	runTimeSupport run: aString! !

!RunTimeMirror methodsFor: 'method' stamp: 'NickPapoulias 1/31/2013 12:05'!
selectorOfMethod: aMethod

	^ runTimeSupport selectorOfMethod: aMethod! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:05'!
selectorsOfClass: aClass

	^ (runTimeSupport selectorsOfClass: aClass) asLocalObject ! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:06'!
setIvs: ivs forClass: aClass

	runTimeSupport setIvs: ivs forClass: aClass! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 17:07'!
soleInstanceFor: metaClass

	^ Reflection on: (runTimeSupport soleInstanceFor: metaClass)! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 4/11/2013 18:39'!
sourceForContext: aContext

	^ runTimeSupport sourceForContext: aContext ! !

!RunTimeMirror methodsFor: 'method' stamp: 'NickPapoulias 1/31/2013 12:07'!
sourceOfMethod: aMethod

	^ runTimeSupport sourceOfMethod: aMethod ! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 15:05'!
sourceRangeForProcess: aProcess

	^ (runTimeSupport sourceRangeForProcess: aProcess) asLocalObject 
	! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 13:58'!
stackForProcess: aProcess

	|contextMirrors|
	
	contextMirrors := OrderedCollection new.
	
	(runTimeSupport stackForProcess: aProcess) do: [:exception | 
		contextMirrors add: (Reflection on: exception)	
	].

	^ contextMirrors.
	! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 1/31/2013 12:10'!
tempNamed: aTempName inContext: aContext 

	^ Reflection on: (runTimeSupport tempNamed: aTempName inContext: aContext).! !

!RunTimeMirror methodsFor: 'context' stamp: 'NickPapoulias 1/31/2013 12:39'!
tempNamesForContext: aContext 

	^ (runTimeSupport tempNamesForContext: aContext) asLocalObject ! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:12'!
throughForProcess: aProcess 

	runTimeSupport throughForProcess: aProcess
	! !

!RunTimeMirror methodsFor: 'environment' stamp: 'NickPapoulias 4/8/2013 12:17'!
unhandledExceptions 

	|exceptionMirrors|
	
	exceptionMirrors := OrderedCollection new.
	
	runTimeSupport unhandledExceptions do: [:exception | 
		exceptionMirrors add: (Reflection on: exception)	
	].

	^ exceptionMirrors.
	! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:39'!
vm_basicSizeOf: anObject

	runTimeSupport vm_basicSizeOf: anObject.! !

!RunTimeMirror methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:24'!
vm_changeSuperClassOf: aClass To: aClassNameAsString

	runTimeSupport vm_changeSuperClassOf: aClass To: aClassNameAsString ! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:24'!
vm_classNameOf: anObject

	^ runTimeSupport vm_classNameOf: anObject! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:39'!
vm_classOf: anObject

	^ Reflection on: (runTimeSupport vm_classOf: anObject)! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:25'!
vm_indexedOf: anObject at: index
	
	^ Reflection on: (runTimeSupport vm_indexedOf: anObject at: index)! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:26'!
vm_indexedOf: anObject at: index put: anotherObject

	runTimeSupport vm_indexedOf: anObject at: index  put: anotherObject! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:27'!
vm_instSizeOf: anObject

	^ runTimeSupport vm_instSizeOf: anObject! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:40'!
vm_instVarOf: anObject at: index
	
	^ Reflection on: (runTimeSupport vm_instVarOf: anObject at: index)

	! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:32'!
vm_instVarOf: anObject at: index put: anotherObject
	
	runTimeSupport vm_instVarOf: anObject at: index  put: anotherObject ! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:33'!
vm_instVarOf: anObject named: anIvName

	^ Reflection on: (runTimeSupport vm_instVarOf: anObject named: anIvName)
	! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:33'!
vm_instVarOf: anObject named: anIvName put: aValue

	runTimeSupport vm_instVarOf: anObject named: anIvName  put: aValue ! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:34'!
vm_objAsStringFor: anObject

	^ runTimeSupport vm_objAsStringFor: anObject! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:36'!
vm_objectFormatOf: anObject


	^ runTimeSupport vm_objectFormatOf: anObject ! !

!RunTimeMirror methodsFor: 'object' stamp: 'NickPapoulias 1/31/2013 12:36'!
vm_objectTypeOf: anObject

	^ runTimeSupport vm_objectTypeOf: anObject! !

!RunTimeMirror methodsFor: 'process' stamp: 'NickPapoulias 1/31/2013 12:36'!
whereForProcess: aProcess 

	^ (runTimeSupport whereForProcess: aProcess) asLocalObject 
	! !

Object subclass: #MyClass
	instanceVariableNames: 'myInstanceVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MyProject'!

!Object methodsFor: '*Mercury-Prototype' stamp: 'NickPapoulias 1/9/2013 12:16'!
isMirror

	^ false! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/9/2013 10:45'!
xxx___isRemoteEnvironmentId 

	^ false! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/29/2013 12:12'!
xxx___runTimeDebuggingSupport 

	^ (Smalltalk globals at: #RunTimeDebuggingSupport) ! !

Object subclass: #ProcessSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

ProcessSecurityPolicy subclass: #IntercessionSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

!IntercessionSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/9/2013 14:30'!
reflectionClasses

	^ {'Object' -> ObjectIntercessionMirror . 'ClassDescription' -> ClassIntercessionMirror . 'ContextPart' -> ContextIntercessionMirror . 'SystemDictionary' -> EnvironmentIntercessionMirror . 'Exception' -> ExceptionIntercessionMirror . 'CompiledMethod' -> MethodIntercessionMirror . 'PackageInfo' -> PackageIntercessionMirror . 'Process' -> ProcessIntercessionMirror} asDictionary ! !

!IntercessionSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:37'!
reflectionClasses

	^ {'Object' -> ObjectIntercessionMirror . 'Class' -> ClassIntercessionMirror . 'ContextPart' -> ContextIntercessionMirror . 'SystemDictionary' -> EnvironmentIntercessionMirror . 'Exception' -> ExceptionIntercessionMirror . 'CompiledMethod' -> MethodIntercessionMirror . 'PackageInfo' -> PackageIntercessionMirror . 'Process' -> ProcessIntercessionMirror} asDictionary ! !

ProcessSecurityPolicy subclass: #IntrospectionSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

!IntrospectionSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/9/2013 14:30'!
reflectionClasses

	^ {'Object' -> ObjectIntrospectionMirror . 'ClassDescription' -> ClassIntrospectionMirror . 'ContextPart' -> ContextIntrospectionMirror . 'SystemDictionary' -> EnvironmentIntrospectionMirror . 'Exception' -> ExceptionIntrospectionMirror . 'CompiledMethod' -> MethodIntrospectionMirror . 'PackageInfo' -> PackageIntrospectionMirror . 'Process' -> ProcessIntrospectionMirror} asDictionary ! !

!IntrospectionSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:38'!
reflectionClasses

	^ {'Object' -> ObjectIntrospectionMirror . 'Class' -> ClassIntrospectionMirror . 'ContextPart' -> ContextIntrospectionMirror . 'SystemDictionary' -> EnvironmentIntrospectionMirror . 'Exception' -> ExceptionIntrospectionMirror . 'CompiledMethod' -> MethodIntrospectionMirror . 'PackageInfo' -> PackageIntrospectionMirror . 'Process' -> ProcessIntrospectionMirror} asDictionary ! !

!ProcessSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 11:25'!
reflectionClasses

	self subclassResponsibility ! !

!ProcessSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:36'!
reflectionClasses

	self subclassResponsibility ! !

Object subclass: #Reflection
	instanceVariableNames: ''
	classVariableNames: 'environmentMirrorsDict'
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 13:20'!
authenticateOn: aRemoteEnvironment 

	"in the prototype authentication is handled automatically by the middleware,
	see SeamlessAuthenticationManager, this means that without the right credentials
	the middleware in the other side will not respond at the authenticate message send
	to the debugging seed"
	
	(aRemoteEnvironment = ('127.0.0.1' , SeamlessDeamonManager default defaultPort asString)) ifTrue: [
		^ self onLocalEnvironment. 
	].
	
	^ Reflection on: (DebuggingSeed from: aRemoteEnvironment target) authenticate
	! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/31/2013 12:52'!
on: anObject

	|kernelClassOfObject|
	
	anObject xxx___isRemoteEnvironmentId ifTrue: [
		^ self onEnvironment: anObject.
	].
	
	kernelClassOfObject := anObject xxx___runTimeDebuggingSupport vm_kernelClassOf: anObject.
	
	^ (Processor activeProcess reflectionPolicy reflectionClasses at: kernelClassOfObject)
		newWith: anObject and: (RunTimeMirror newWith: (anObject xxx___runTimeDebuggingSupport)) ! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:51'!
onEnvironment: aRemoteEnvironment

	^ self authenticateOn: aRemoteEnvironment 

	! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 11:15'!
onLocalEnvironment

	^ Reflection on: Smalltalk globals

	! !

Object subclass: #RemoteEnvironment
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

!RemoteEnvironment class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
@ aString

	^ self new target: aString! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
target

	^ target! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
target: aString
	
	target := aString! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:47'!
xxx___isRemoteEnvironmentId 

	^ true! !

Object subclass: #RunTimeDebuggingSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:35'!
addInstVarNamed: anIvName inClass: baseObject

	baseObject addInstVarNamed: anIvName ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 2/19/2013 13:56'!
addMethod: aString inClass: aClass

	^ aClass compile: aString "returns a symbol"

! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 16:21'!
changeClassTo: aClassNameAsString of: anObject
	
	self vm_changeClassTo: (Smalltalk globals at: aClassNameAsString asSymbol) of: anObject ! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/9/2013 12:05'!
classNamed: aClassNameAsString inPackage: baseObject

	^ (baseObject classes select: [:class | class name = aClassNameAsString]) first! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 2/19/2013 10:48'!
classNamesInPackage: baseObject

	^ (baseObject classes collect: [:class | class name])! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:19'!
classOfMethod: aMethod

	^ aMethod methodClass! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:29'!
contextAt: aContextIndex forProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	aProcess handler goToStackIndex: aContextIndex.
	^ aProcess handler currentContext.! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 19:01'!
contextForProcess: aProcess 

	aProcess handler currentContext 

	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 14:34'!
currentContextIndexForProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	^ aProcess handler getStackIndex.! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 16:40'!
definitionOfClass: aClass

	"can be done via the rt deb support primitives"

	^ aClass definition ! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/29/2013 20:14'!
descriptionForException: anException

	^ anException description ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/24/2013 13:13'!
dictionaryForContext: aContext

	|dict names namesValuesAssocs|

	names := aContext debuggerMap tempNamesForContext: aContext.
	namesValuesAssocs := OrderedCollection new.
	names doWithIndex: [:item :index |
		namesValuesAssocs add: item -> (aContext debuggerMap namedTempAt: index in: aContext) printString.
	].
	dict := Dictionary newFrom: namesValuesAssocs. 
	dict at: 'thisContext' put: aContext printString.
	
	^ dict.
! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/24/2013 13:13'!
dictionaryForReceiverInContext: aContext

	|receiver dict|
	receiver := aContext receiver.
	dict := Dictionary newFrom: 
		(receiver class allInstVarNames collect: [ :each |
		each -> (receiver instVarNamed: each) printString
	]).

	dict at: 'self' put: receiver printString.
	
	^ dict.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:24'!
environmentAddress 

	^ SeamlessDeamonManager default address! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 8/1/2013 16:18'!
evaluate: aString

	|exception responce|

	[[
		Interpreter enableMetaBehaviorForRegistered.
		responce := Compiler evaluate: aString.
	] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[(responce = nil) & (exception = nil)] whileTrue: [ Processor yield ]. "active waiting on computation"

	^ responce ifNil: [exception]
! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:25'!
globalAt: aName

	^ Smalltalk globals at: aName asSymbol! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:31'!
globalAt: aName put: anObject

	^ Smalltalk globals at: aName asSymbol put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:20'!
globalNames 

	^ Smalltalk globals keys! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 11:23'!
globalsDictionary

	^ Smalltalk globals! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/10/2013 13:16'!
handlerProcessForException: anException

	^ anException handlerProcess ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/9/2013 15:57'!
inContext: baseObject forTempNamed: aTempName put: anObject

	baseObject tempNamed: aTempName put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:53'!
interruptedProcesses

	^ DebuggingSeed interruptedProcesses! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/11/2013 18:57'!
intoForProcess: aProcess 

	aProcess handler into

	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 16:55'!
isMetaForClass: aClass

	^ aClass class = Metaclass! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 15:05'!
ivsForClass: aClass

	^ self vm_instVarOf: aClass at: 4.! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 4/9/2013 14:32'!
kernelClasses

	^ {'Object'  . 'ClassDescription'  . 'ContextPart'  . 'SystemDictionary'  . 'Exception'  . 'CompiledMethod'  . 'PackageInfo'  . 'Process' } 
	! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 12/24/2012 17:04'!
metaLevelUpdate: aSystemAnnouncement! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:51'!
methodForContext: aContext 

	^ aContext method! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 12:07'!
methodOf: aClass at: aMethodName 
	
	^ aClass methodDict at: aMethodName ! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:52'!
methodsOf: aClass inProtocol: aProtocolName 
	
	|methodNames|
	
	methodNames := OrderedCollection new.
	
	aClass methodDict do: [:method |
		
		method protocol = aProtocolName ifTrue: [methodNames add: method selector]
			
	].

	^ methodNames ! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 19:10'!
nameForProcess: aProcess 

	^ aProcess name

	

	! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/29/2013 20:12'!
nameOfPackage: aPackage 

	^ aPackage packageName! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/11/2013 12:07'!
newClassNamed: aNewClassName inPackage: aPackage

	^ Object subclass: aNewClassName asSymbol  
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aPackage externalName. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/9/2013 12:08'!
newInstanceForClass: aClass

	"can be done through vm primitive"

	^ aClass new! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/11/2013 11:00'!
newPackageNamed: aPackageName

	^ PackageOrganizer default packageNamed: aPackageName ifAbsent: [(PackageInfo new packageName: aPackageName) register]! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/21/2013 16:24'!
objectHalt: anObject

	anObject halt! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:49'!
onArgumentFor: anObject do: aBlock

	Interpreter on: AsArgument for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:49'!
onInteractionFor: anObject with: anotherObject do: aBlock


	Interpreter on: (ObjectInteraction with: anotherObject) for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:53'!
onNewForClass: aClass do: aBlock

	| localCallback |
	
	localCallback := (Compiler evaluate: aBlock asString).

	Interpreter on: MessageReceived for: aClass do: [:reifications :reflectogram | 
		
		reifications message selector = #new ifTrue: [
			localCallback value: reifications value: reflectogram.
		].
				
	]. ! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:54'!
onReadFor: anObject do: aBlock


	Interpreter on: IvRead for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:54'!
onReadForClass: aClass do: aBlock

	aClass allInstances do: [:inst |
		self onReadFor: inst do: aBlock 
	].! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 16:49'!
onReceiveFor: anObject do: aBlock

	"local callback"

	Interpreter on: MessageReceived for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:55'!
onSendFor: anObject do: aBlock

	Interpreter on: MessageSent for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:55'!
onStoreFor: anObject do: aBlock

	Interpreter on: Stored for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:56'!
onWriteFor: anObject do: aBlock

	Interpreter on: IvWrite for: anObject do: (Compiler evaluate: aBlock asString).! !

!RunTimeDebuggingSupport class methodsFor: 'intercession' stamp: 'NickPapoulias 6/22/2013 18:56'!
onWriteForClass: aClass do: aBlock

	aClass allInstances do: [:inst |
		self onReadFor: inst do: aBlock 
	].! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:37'!
overForProcess: aProcess 

	aProcess handler over

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:40'!
packageNamed: aPackageNameAsString 

	"this can be done through vm access in order to avoid local reflection dependency,
	after bootstraping the mirror hierarchy ideally this dependency is not needed"

	^ self packagesDictionary at: aPackageNameAsString ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 10:44'!
packageNames

	^ PackageOrganizer default packageNames! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/8/2013 15:34'!
packageOfClass: aClass

	^ PackageOrganizer default packageOfClass: aClass.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/13/2013 18:34'!
packages

	^ PackageOrganizer default packages ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:39'!
packagesDictionary

	^ PackageOrganizer default instVarNamed: #packages! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 8/2/2013 12:41'!
perform: aSelector withReceiver: baseObject andArguments: arguments
	
	|exception responce args|

	arguments xxx___isProxy ifTrue: [
		args := arguments asLocalObject "better as shallowCopy"		
	] ifFalse: [
		args := arguments
	].

	[[responce := baseObject perform: aSelector withArguments: args] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[(responce = nil) & (exception = nil)] whileTrue: [ Processor yield ]. "active waiting on computation"

	^ responce ifNil: [exception]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:34'!
proceedForProcess: aProcess 

	aProcess handler proceed 

	! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:16'!
protocolOfMethod: aMethod

	^ aMethod protocol! !

!RunTimeDebuggingSupport class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 2/19/2013 11:31'!
protocolsForClass: aClass 

	|protocols|
	
	protocols := Set new.

	aClass methodDict do: [:method | protocols add: method protocol].
	
	^ protocols asOrderedCollection.! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:51'!
receiverForContext: aContext 

	^ aContext receiver! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/12/2013 16:00'!
recompileCurrentMethodTo: aText forProcess: aProcess

	^ aProcess handler
		recompileCurrentMethodTo:  aText 
	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/24/2013 16:37'!
registerExceptionListener: aRequestor

	DebuggingSeed pushNewExceptionsTo: aRequestor.! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:35'!
removeInstVarNamed: anIvName inClass: baseObject

	baseObject removeInstVarNamed: anIvName ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:45'!
removeMethod: aString inClass: aClass

	aClass removeSelector: aString asSymbol 

! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 20:33'!
removePackageNamed: aPackageName

	^ PackageOrganizer default unregisterPackageNamed: aPackageName! !

!RunTimeDebuggingSupport class methodsFor: 'distribution' stamp: 'NickPapoulias 6/25/2013 15:13'!
resolveLocallyToDepth: n forObject:  anObject

	| objectGraph resolveRecursion |
	
	resolveRecursion := [:object :i | |objG|
		i = 0 
			ifTrue: [#() asDictionary] "leaf"
			ifFalse: [
				objG := Dictionary new. 
				object class instVarNames do: [:instName | |instance|
					instance := (object instVarNamed: instName).
					objG at: {instName . self vm_kernelClassOf: instance. instance asString} put: (resolveRecursion value: (object instVarNamed: instName) value: i-1)
				].
				objG.
			] 	
	].

	objectGraph := Dictionary new.
	objectGraph at: {'self' . self vm_kernelClassOf: anObject . anObject asString} put: (resolveRecursion value: anObject value: n).
	^ objectGraph.
	
! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
restartForProcess: aProcess 

	aProcess handler restart

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:15'!
run: aString

	[DebuggingSeed run: aString] fork. "will unload the RTSupport package"! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:17'!
selectorOfMethod: aMethod

	^ aMethod selector! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 18:30'!
selectorsOfClass: aClass

	^ aClass methodDict keys! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:15'!
setIvs: ivs forClass: aClass

	self vm_instVarOf: aClass at: 4 put: ivs. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 4/11/2013 17:07'!
soleInstanceFor: metaClass

	^ metaClass soleInstance ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 4/11/2013 18:50'!
sourceForContext: aContext

	^ aContext debuggerMap sourceText! !

!RunTimeDebuggingSupport class methodsFor: 'method' stamp: 'NickPapoulias 1/29/2013 18:17'!
sourceOfMethod: aMethod

	^ aMethod sourceCode! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 15:05'!
sourceRangeForProcess: aProcess

	^ aProcess handler getCurrentPosition 

	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 4/8/2013 13:59'!
stackForProcess: aProcess

	^ aProcess handler stack 

	! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/11/2013 10:42'!
tempNamed: aTempName inContext: aContext 

	^ aContext tempNamed: aTempName! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/29/2013 18:54'!
tempNamesForContext: aContext 

	^ aContext tempNames! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
throughForProcess: aProcess 

	aProcess handler through 

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/31/2013 12:54'!
unhandledExceptions 

	^ DebuggingSeed unhandledExceptions ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_basicSizeOf: anObject

	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_changeClassTo: anotherClass of: anObject
	
	<primitive: 160 error: ec>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 16:43'!
vm_changeSuperClassOf: aClass To: aClassNameAsString

	self instVarOf: aClass at: 1 put: (Smalltalk globals at: aClassNameAsString) ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 12:45'!
vm_classNameOf: anObject

	(self vm_classOf: anObject) asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_classOf: anObject

	<primitive: 111>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_environment

	^ Smalltalk globals ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_indexedOf: anObject at: index
	<primitive: 60>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:09'!
vm_indexedOf: anObject at: index put: anotherObject
	<primitive: 61>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instSizeOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ ((cformat bitShift: -10) bitAnd: 16rC0) + ((cformat bitShift: -1) bitAnd: 16r3F) - 1
	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/31/2013 12:31'!
vm_instVarIndexOf: anIvName forClass: aClass

	| index superC |
	superC := (self vm_instVarOf: aClass at: 1).
	index := (self ivsForClass: aClass) == nil 
		ifTrue: [0]
		ifFalse: [(self ivsForClass: aClass) indexOf: anIvName].
	index = 0 ifTrue: 
		[^superC == nil 
			ifTrue: [0]
			ifFalse: [self instVarIndexFor: anIvName forClass: superC]].
	^superC == nil 	
		ifTrue: [index]
		ifFalse: [index + superC instSize]! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 16:27'!
vm_instVarNamesOf: anObject

	^ self ivsForClass: (self vm_classOf: anObject) ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index
	<primitive: 73>
	self primitiveFailed

	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index put: anotherObject
	<primitive: 74>
	self primitiveFailed
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:09'!
vm_instVarOf: anObject named: anIvName

	"this can be done via primitives"

	^ self vm_instVarOf: anObject at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject))
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:12'!
vm_instVarOf: anObject named: anIvName put: aValue

	"this can be done via primitives"

	self vm_instVarOf: anObject 
		at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject)) 
		put: aValue
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:15'!
vm_kernelClassOf: anObject

	|classOfObject|

	classOfObject := self vm_classOf: anObject.
	
	[self kernelClasses includes: classOfObject asString] whileFalse: [
		classOfObject := self vm_instVarOf: classOfObject at: 1 "check the superclass"
	].

	^ classOfObject asString
		
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/9/2013 12:23'!
vm_objAsStringFor: baseObject

	^ baseObject asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_object: anObject equals: anotherObject

	<primitive: 110>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectFormatOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ cformat! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectTypeOf: anObject

	"see behavior type of class"
	
	|instSpec|
	
	instSpec := ((self vm_objectFormatOf: anObject) bitShift: -7) bitAnd: 16rF.
	instSpec = 12 ifTrue:[^#compiledMethod]. "Very special!!"
	instSpec >= 8 ifTrue:[^#bytes].
	((instSpec >= 8) not and:[(instSpec >= 6)]) ifTrue:[^#words].
	instSpec = 4 ifTrue:[^#weak].
	instSpec >= 2 ifTrue:[^#variable].
	^#normal.
	! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 19:03'!
whereForProcess: aProcess 

	^ aProcess handler where

	! !

Object subclass: #TestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!TestClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/22/2013 16:57'!
run

	Point new.! !
MercurySeamlessDeamon initialize!
